using System;
using System.Net;
using System.IO;
using System.Threading;
using System.Collections;
using System.Diagnostics;

namespace WebDownloader
{
	public class CDownloadManager
	{

		private string strUrl;
		private string strUid;
		private string strPwd;
		private string localpath;
		private HttpWebRequest request;
		private HttpWebResponse response;
		private Hashtable arrlst=new Hashtable();

		public delegate void OnDownloadCompleteDelegate(string localpath);
		public event OnDownloadCompleteDelegate OnDownloadComplete;

		public CDownloadManager()
		{
		}

		public string Url
		{
			get
			{
				return strUrl;
			}
			set
			{
				strUrl=value;
			}
		}

		public string UserID
		{
			get
			{
				return strUid;
			}
			set
			{
				strUid=value;
			}
		}

		public string Password
		{
			get
			{
				return strPwd;
			}
			set
			{
				strPwd=value;
			}
		}

		public int GetBytesRead(string localpath)
		{
			return (int)arrlst[localpath];
		}

		public string Download(string localpath)
		{
			this.localpath=localpath;
			Thread th=new Thread(new ThreadStart(DownloadInNewThread));
			th.Name=localpath;
			th.Start();
			arrlst.Add(localpath,0);
			return "";
		}

		private void DownloadInNewThread()
		{
			request=(HttpWebRequest)HttpWebRequest.Create(new Uri(Url));
			response=(HttpWebResponse)request.GetResponse();

			Stream responsestream=response.GetResponseStream();
			FileStream fs=new FileStream(localpath,FileMode.Create);
			while(true)
			{
				int retval=responsestream.ReadByte();
				if(retval!=-1)
				{
					fs.WriteByte((byte)retval);
					int i=(int)arrlst[Thread.CurrentThread.Name];
					arrlst[Thread.CurrentThread.Name]=++i;
				}
				else
					break;

			}
			OnDownloadComplete(Thread.CurrentThread.Name);
		}
	}
}
